diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.6.pl /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/post.php /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/post.php
*** /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/post.php	2013-04-04 10:57:46.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/post.php	2013-07-20 15:20:47.000000000 -0500
***************
*** 3996,4002 ****
  
  	// expected_slashed (everything!)
  	$data = compact( array( 'post_author', 'post_date', 'post_date_gmt', 'post_content', 'post_content_filtered', 'post_title', 'post_excerpt', 'post_status', 'post_type', 'comment_status', 'ping_status', 'post_password', 'post_name', 'to_ping', 'pinged', 'post_modified', 'post_modified_gmt', 'post_parent', 'menu_order', 'post_mime_type', 'guid' ) );
! 	$data = stripslashes_deep( $data );
  
  	if ( $update ) {
  		$wpdb->update( $wpdb->posts, $data, array( 'ID' => $post_ID ) );
--- 3967,3973 ----
  
  	// expected_slashed (everything!)
  	$data = compact( array( 'post_author', 'post_date', 'post_date_gmt', 'post_content', 'post_content_filtered', 'post_title', 'post_excerpt', 'post_status', 'post_type', 'comment_status', 'ping_status', 'post_password', 'post_name', 'to_ping', 'pinged', 'post_modified', 'post_modified_gmt', 'post_parent', 'menu_order', 'post_mime_type', 'guid' ) );
! 	$data = wp_unslash( $data );
  
  	if ( $update ) {
  		$wpdb->update( $wpdb->posts, $data, array( 'ID' => $post_ID ) );
***************
*** 4632,4638 ****
   *
   * @uses do_action() Calls 'clean_post_cache' on $id before adding children (if any).
   *
!  * @param object|int $post The post object or ID to remove from the cache
   */
  function clean_post_cache( $post ) {
  	global $_wp_suspend_cache_invalidation, $wpdb;
--- 4603,4609 ----
   *
   * @uses do_action() Calls 'clean_post_cache' on $id before adding children (if any).
   *
!  * @param int|object $post Post ID or object to remove from the cache
   */
  function clean_post_cache( $post ) {
  	global $_wp_suspend_cache_invalidation, $wpdb;
***************
*** 4660,4665 ****
--- 4631,4638 ----
  		wp_cache_delete( 'all_page_ids', 'posts' );
  		do_action( 'clean_page_cache', $post->ID );
  	}
+ 
+ 	wp_cache_set( 'last_changed', microtime(), 'posts' );
  }
  
  /**
***************
*** 4820,4826 ****
   *   wp_transition_post_status() and the default filter for _future_post_hook().
   * @param object $post Object type containing the post information
   */
! function _future_post_hook( $deprecated = '', $post ) {
  	wp_clear_scheduled_hook( 'publish_future_post', array( $post->ID ) );
  	wp_schedule_single_event( strtotime( get_gmt_from_date( $post->post_date ) . ' GMT') , 'publish_future_post', array( $post->ID ) );
  }
--- 4793,4799 ----
   *   wp_transition_post_status() and the default filter for _future_post_hook().
   * @param object $post Object type containing the post information
   */
! function _future_post_hook( $deprecated, $post ) {
  	wp_clear_scheduled_hook( 'publish_future_post', array( $post->ID ) );
  	wp_schedule_single_event( strtotime( get_gmt_from_date( $post->post_date ) . ' GMT') , 'publish_future_post', array( $post->ID ) );
  }
***************
*** 4830,4844 ****
   *
   * @since 2.3.0
   * @access private
!  * @uses $wpdb
!  * @uses XMLRPC_REQUEST constant.
!  * @uses do_action() Calls 'xmlprc_publish_post' on post ID if XMLRPC_REQUEST is defined.
   *
   * @param int $post_id The ID in the database table of the post being published
   */
  function _publish_post_hook($post_id) {
- 	global $wpdb;
- 
  	if ( defined('XMLRPC_REQUEST') )
  		do_action('xmlrpc_publish_post', $post_id);
  
--- 4803,4814 ----
   *
   * @since 2.3.0
   * @access private
!  * @uses XMLRPC_REQUEST and WP_IMPORTING constants.
!  * @uses do_action() Calls 'xmlrpc_publish_post' on post ID if XMLRPC_REQUEST is defined.
   *
   * @param int $post_id The ID in the database table of the post being published
   */
  function _publish_post_hook($post_id) {
  	if ( defined('XMLRPC_REQUEST') )
  		do_action('xmlrpc_publish_post', $post_id);
  
***************
*** 4853,5257 ****
  }
  
  /**
-  * Determines which fields of posts are to be saved in revisions.
-  *
-  * Does two things. If passed a post *array*, it will return a post array ready
-  * to be inserted into the posts table as a post revision. Otherwise, returns
-  * an array whose keys are the post fields to be saved for post revisions.
-  *
-  * @package WordPress
-  * @subpackage Post_Revisions
-  * @since 2.6.0
-  * @access private
-  * @uses apply_filters() Calls '_wp_post_revision_fields' on 'title', 'content' and 'excerpt' fields.
-  *
-  * @param array $post Optional a post array to be processed for insertion as a post revision.
-  * @param bool $autosave optional Is the revision an autosave?
-  * @return array Post array ready to be inserted as a post revision or array of fields that can be versioned.
-  */
- function _wp_post_revision_fields( $post = null, $autosave = false ) {
- 	static $fields = false;
- 
- 	if ( !$fields ) {
- 		// Allow these to be versioned
- 		$fields = array(
- 			'post_title' => __( 'Title' ),
- 			'post_content' => __( 'Content' ),
- 			'post_excerpt' => __( 'Excerpt' ),
- 		);
- 
- 		// Runs only once
- 		$fields = apply_filters( '_wp_post_revision_fields', $fields );
- 
- 		// WP uses these internally either in versioning or elsewhere - they cannot be versioned
- 		foreach ( array( 'ID', 'post_name', 'post_parent', 'post_date', 'post_date_gmt', 'post_status', 'post_type', 'comment_count', 'post_author' ) as $protect )
- 			unset( $fields[$protect] );
- 	}
- 
- 	if ( !is_array($post) )
- 		return $fields;
- 
- 	$return = array();
- 	foreach ( array_intersect( array_keys( $post ), array_keys( $fields ) ) as $field )
- 		$return[$field] = $post[$field];
- 
- 	$return['post_parent']   = $post['ID'];
- 	$return['post_status']   = 'inherit';
- 	$return['post_type']     = 'revision';
- 	$return['post_name']     = $autosave ? "$post[ID]-autosave" : "$post[ID]-revision";
- 	$return['post_date']     = isset($post['post_modified']) ? $post['post_modified'] : '';
- 	$return['post_date_gmt'] = isset($post['post_modified_gmt']) ? $post['post_modified_gmt'] : '';
- 
- 	return $return;
- }
- 
- /**
-  * Saves an already existing post as a post revision.
-  *
-  * Typically used immediately prior to post updates.
-  *
-  * @package WordPress
-  * @subpackage Post_Revisions
-  * @since 2.6.0
-  *
-  * @uses _wp_put_post_revision()
-  *
-  * @param int $post_id The ID of the post to save as a revision.
-  * @return mixed Null or 0 if error, new revision ID, if success.
-  */
- function wp_save_post_revision( $post_id ) {
- 	// We do autosaves manually with wp_create_post_autosave()
- 	if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE )
- 		return;
- 
- 	// WP_POST_REVISIONS = 0, false
- 	if ( ! WP_POST_REVISIONS )
- 		return;
- 
- 	if ( !$post = get_post( $post_id, ARRAY_A ) )
- 		return;
- 
- 	if ( 'auto-draft' == $post['post_status'] )
- 		return;
- 
- 	if ( !post_type_supports($post['post_type'], 'revisions') )
- 		return;
- 
- 	$return = _wp_put_post_revision( $post );
- 
- 	// WP_POST_REVISIONS = true (default), -1
- 	if ( !is_numeric( WP_POST_REVISIONS ) || WP_POST_REVISIONS < 0 )
- 		return $return;
- 
- 	// all revisions and (possibly) one autosave
- 	$revisions = wp_get_post_revisions( $post_id, array( 'order' => 'ASC' ) );
- 
- 	// WP_POST_REVISIONS = (int) (# of autosaves to save)
- 	$delete = count($revisions) - WP_POST_REVISIONS;
- 
- 	if ( $delete < 1 )
- 		return $return;
- 
- 	$revisions = array_slice( $revisions, 0, $delete );
- 
- 	for ( $i = 0; isset($revisions[$i]); $i++ ) {
- 		if ( false !== strpos( $revisions[$i]->post_name, 'autosave' ) )
- 			continue;
- 		wp_delete_post_revision( $revisions[$i]->ID );
- 	}
- 
- 	return $return;
- }
- 
- /**
-  * Retrieve the autosaved data of the specified post.
-  *
-  * Returns a post object containing the information that was autosaved for the
-  * specified post.
-  *
-  * @package WordPress
-  * @subpackage Post_Revisions
-  * @since 2.6.0
-  *
-  * @param int $post_id The post ID.
-  * @return object|bool The autosaved data or false on failure or when no autosave exists.
-  */
- function wp_get_post_autosave( $post_id ) {
- 
- 	if ( !$post = get_post( $post_id ) )
- 		return false;
- 
- 	$q = array(
- 		'name' => "{$post->ID}-autosave",
- 		'post_parent' => $post->ID,
- 		'post_type' => 'revision',
- 		'post_status' => 'inherit'
- 	);
- 
- 	// Use WP_Query so that the result gets cached
- 	$autosave_query = new WP_Query;
- 
- 	add_action( 'parse_query', '_wp_get_post_autosave_hack' );
- 	$autosave = $autosave_query->query( $q );
- 	remove_action( 'parse_query', '_wp_get_post_autosave_hack' );
- 
- 	if ( $autosave && is_array($autosave) && is_object($autosave[0]) )
- 		return $autosave[0];
- 
- 	return false;
- }
- 
- /**
-  * Internally used to hack WP_Query into submission.
-  *
-  * @package WordPress
-  * @subpackage Post_Revisions
-  * @since 2.6.0
-  *
-  * @param object $query WP_Query object
-  */
- function _wp_get_post_autosave_hack( $query ) {
- 	$query->is_single = false;
- }
- 
- /**
-  * Determines if the specified post is a revision.
-  *
-  * @package WordPress
-  * @subpackage Post_Revisions
-  * @since 2.6.0
-  *
-  * @param int|object $post Post ID or post object.
-  * @return bool|int False if not a revision, ID of revision's parent otherwise.
-  */
- function wp_is_post_revision( $post ) {
- 	if ( !$post = wp_get_post_revision( $post ) )
- 		return false;
- 	return (int) $post->post_parent;
- }
- 
- /**
-  * Determines if the specified post is an autosave.
-  *
-  * @package WordPress
-  * @subpackage Post_Revisions
-  * @since 2.6.0
-  *
-  * @param int|object $post Post ID or post object.
-  * @return bool|int False if not a revision, ID of autosave's parent otherwise
-  */
- function wp_is_post_autosave( $post ) {
- 	if ( !$post = wp_get_post_revision( $post ) )
- 		return false;
- 	if ( "{$post->post_parent}-autosave" !== $post->post_name )
- 		return false;
- 	return (int) $post->post_parent;
- }
- 
- /**
-  * Inserts post data into the posts table as a post revision.
-  *
-  * @package WordPress
-  * @subpackage Post_Revisions
-  * @since 2.6.0
-  *
-  * @uses wp_insert_post()
-  *
-  * @param int|object|array $post Post ID, post object OR post array.
-  * @param bool $autosave Optional. Is the revision an autosave?
-  * @return mixed Null or 0 if error, new revision ID if success.
-  */
- function _wp_put_post_revision( $post = null, $autosave = false ) {
- 	if ( is_object($post) )
- 		$post = get_object_vars( $post );
- 	elseif ( !is_array($post) )
- 		$post = get_post($post, ARRAY_A);
- 	if ( !$post || empty($post['ID']) )
- 		return;
- 
- 	if ( isset($post['post_type']) && 'revision' == $post['post_type'] )
- 		return new WP_Error( 'post_type', __( 'Cannot create a revision of a revision' ) );
- 
- 	$post = _wp_post_revision_fields( $post, $autosave );
- 	$post = add_magic_quotes($post); //since data is from db
- 
- 	$revision_id = wp_insert_post( $post );
- 	if ( is_wp_error($revision_id) )
- 		return $revision_id;
- 
- 	if ( $revision_id )
- 		do_action( '_wp_put_post_revision', $revision_id );
- 	return $revision_id;
- }
- 
- /**
-  * Gets a post revision.
-  *
-  * @package WordPress
-  * @subpackage Post_Revisions
-  * @since 2.6.0
-  *
-  * @uses get_post()
-  *
-  * @param int|object $post Post ID or post object
-  * @param string $output Optional. OBJECT, ARRAY_A, or ARRAY_N.
-  * @param string $filter Optional sanitation filter. @see sanitize_post()
-  * @return mixed Null if error or post object if success
-  */
- function wp_get_post_revision(&$post, $output = OBJECT, $filter = 'raw') {
- 	$null = null;
- 	if ( !$revision = get_post( $post, OBJECT, $filter ) )
- 		return $revision;
- 	if ( 'revision' !== $revision->post_type )
- 		return $null;
- 
- 	if ( $output == OBJECT ) {
- 		return $revision;
- 	} elseif ( $output == ARRAY_A ) {
- 		$_revision = get_object_vars($revision);
- 		return $_revision;
- 	} elseif ( $output == ARRAY_N ) {
- 		$_revision = array_values(get_object_vars($revision));
- 		return $_revision;
- 	}
- 
- 	return $revision;
- }
- 
- /**
-  * Restores a post to the specified revision.
-  *
-  * Can restore a past revision using all fields of the post revision, or only selected fields.
-  *
-  * @package WordPress
-  * @subpackage Post_Revisions
-  * @since 2.6.0
-  *
-  * @uses wp_get_post_revision()
-  * @uses wp_update_post()
-  * @uses do_action() Calls 'wp_restore_post_revision' on post ID and revision ID if wp_update_post()
-  *  is successful.
-  *
-  * @param int|object $revision_id Revision ID or revision object.
-  * @param array $fields Optional. What fields to restore from. Defaults to all.
-  * @return mixed Null if error, false if no fields to restore, (int) post ID if success.
-  */
- function wp_restore_post_revision( $revision_id, $fields = null ) {
- 	if ( !$revision = wp_get_post_revision( $revision_id, ARRAY_A ) )
- 		return $revision;
- 
- 	if ( !is_array( $fields ) )
- 		$fields = array_keys( _wp_post_revision_fields() );
- 
- 	$update = array();
- 	foreach( array_intersect( array_keys( $revision ), $fields ) as $field )
- 		$update[$field] = $revision[$field];
- 
- 	if ( !$update )
- 		return false;
- 
- 	$update['ID'] = $revision['post_parent'];
- 
- 	$update = add_magic_quotes( $update ); //since data is from db
- 
- 	$post_id = wp_update_post( $update );
- 	if ( is_wp_error( $post_id ) )
- 		return $post_id;
- 
- 	if ( $post_id )
- 		do_action( 'wp_restore_post_revision', $post_id, $revision['ID'] );
- 
- 	return $post_id;
- }
- 
- /**
-  * Deletes a revision.
-  *
-  * Deletes the row from the posts table corresponding to the specified revision.
-  *
-  * @package WordPress
-  * @subpackage Post_Revisions
-  * @since 2.6.0
-  *
-  * @uses wp_get_post_revision()
-  * @uses wp_delete_post()
-  *
-  * @param int|object $revision_id Revision ID or revision object.
-  * @return mixed Null or WP_Error if error, deleted post if success.
-  */
- function wp_delete_post_revision( $revision_id ) {
- 	if ( !$revision = wp_get_post_revision( $revision_id ) )
- 		return $revision;
- 
- 	$delete = wp_delete_post( $revision->ID );
- 	if ( is_wp_error( $delete ) )
- 		return $delete;
- 
- 	if ( $delete )
- 		do_action( 'wp_delete_post_revision', $revision->ID, $revision );
- 
- 	return $delete;
- }
- 
- /**
-  * Returns all revisions of specified post.
-  *
-  * @package WordPress
-  * @subpackage Post_Revisions
-  * @since 2.6.0
-  *
-  * @uses get_children()
-  *
-  * @param int|object $post_id Post ID or post object
-  * @return array empty if no revisions
-  */
- function wp_get_post_revisions( $post_id = 0, $args = null ) {
- 	if ( ! WP_POST_REVISIONS )
- 		return array();
- 	if ( ( !$post = get_post( $post_id ) ) || empty( $post->ID ) )
- 		return array();
- 
- 	$defaults = array( 'order' => 'DESC', 'orderby' => 'date' );
- 	$args = wp_parse_args( $args, $defaults );
- 	$args = array_merge( $args, array( 'post_parent' => $post->ID, 'post_type' => 'revision', 'post_status' => 'inherit' ) );
- 
- 	if ( !$revisions = get_children( $args ) )
- 		return array();
- 	return $revisions;
- }
- 
- function _set_preview($post) {
- 
- 	if ( ! is_object($post) )
- 		return $post;
- 
- 	$preview = wp_get_post_autosave($post->ID);
- 
- 	if ( ! is_object($preview) )
- 		return $post;
- 
- 	$preview = sanitize_post($preview);
- 
- 	$post->post_content = $preview->post_content;
- 	$post->post_title = $preview->post_title;
- 	$post->post_excerpt = $preview->post_excerpt;
- 
- 	return $post;
- }
- 
- function _show_post_preview() {
- 
- 	if ( isset($_GET['preview_id']) && isset($_GET['preview_nonce']) ) {
- 		$id = (int) $_GET['preview_id'];
- 
- 		if ( false == wp_verify_nonce( $_GET['preview_nonce'], 'post_preview_' . $id ) )
- 			wp_die( __('You do not have permission to preview drafts.') );
- 
- 		add_filter('the_preview', '_set_preview');
- 	}
- }
- 
- /**
   * Returns the post's parent's post_ID
   *
   * @since 3.1.0
--- 4823,4828 ----
***************
*** 5311,5367 ****
  }
  
  /**
-  * Returns an array of post format slugs to their translated and pretty display versions
-  *
-  * @since 3.1.0
-  *
-  * @return array The array of translations
-  */
- function get_post_format_strings() {
- 	$strings = array(
- 		'standard' => _x( 'Standard', 'Post format' ), // Special case. any value that evals to false will be considered standard
- 		'aside'    => _x( 'Aside',    'Post format' ),
- 		'chat'     => _x( 'Chat',     'Post format' ),
- 		'gallery'  => _x( 'Gallery',  'Post format' ),
- 		'link'     => _x( 'Link',     'Post format' ),
- 		'image'    => _x( 'Image',    'Post format' ),
- 		'quote'    => _x( 'Quote',    'Post format' ),
- 		'status'   => _x( 'Status',   'Post format' ),
- 		'video'    => _x( 'Video',    'Post format' ),
- 		'audio'    => _x( 'Audio',    'Post format' ),
- 	);
- 	return $strings;
- }
- 
- /**
-  * Retrieves an array of post format slugs.
-  *
-  * @since 3.1.0
-  *
-  * @return array The array of post format slugs.
-  */
- function get_post_format_slugs() {
- 	$slugs = array_keys( get_post_format_strings() );
- 	return array_combine( $slugs, $slugs );
- }
- 
- /**
-  * Returns a pretty, translated version of a post format slug
-  *
-  * @since 3.1.0
-  *
-  * @param string $slug A post format slug
-  * @return string The translated post format name
-  */
- function get_post_format_string( $slug ) {
- 	$strings = get_post_format_strings();
- 	if ( !$slug )
- 		return $strings['standard'];
- 	else
- 		return ( isset( $strings[$slug] ) ) ? $strings[$slug] : '';
- }
- 
- /**
   * Sets a post thumbnail.
   *
   * @since 3.1.0
--- 4882,4887 ----
***************
*** 5398,5418 ****
  }
  
  /**
-  * Returns a link to a post format index.
-  *
-  * @since 3.1.0
-  *
-  * @param string $format Post format
-  * @return string Link
-  */
- function get_post_format_link( $format ) {
- 	$term = get_term_by('slug', 'post-format-' . $format, 'post_format' );
- 	if ( ! $term || is_wp_error( $term ) )
- 		return false;
- 	return get_term_link( $term );
- }
- 
- /**
   * Deletes auto-drafts for new posts that are > 7 days old
   *
   * @since 3.4.0
--- 4918,4923 ----
***************
*** 5427,5524 ****
  }
  
  /**
-  * Filters the request to allow for the format prefix.
-  *
-  * @access private
-  * @since 3.1.0
-  */
- function _post_format_request( $qvs ) {
- 	if ( ! isset( $qvs['post_format'] ) )
- 		return $qvs;
- 	$slugs = get_post_format_slugs();
- 	if ( isset( $slugs[ $qvs['post_format'] ] ) )
- 		$qvs['post_format'] = 'post-format-' . $slugs[ $qvs['post_format'] ];
- 	$tax = get_taxonomy( 'post_format' );
- 	if ( ! is_admin() )
- 		$qvs['post_type'] = $tax->object_type;
- 	return $qvs;
- }
- add_filter( 'request', '_post_format_request' );
- 
- /**
-  * Filters the post format term link to remove the format prefix.
-  *
-  * @access private
-  * @since 3.1.0
-  */
- function _post_format_link( $link, $term, $taxonomy ) {
- 	global $wp_rewrite;
- 	if ( 'post_format' != $taxonomy )
- 		return $link;
- 	if ( $wp_rewrite->get_extra_permastruct( $taxonomy ) ) {
- 		return str_replace( "/{$term->slug}", '/' . str_replace( 'post-format-', '', $term->slug ), $link );
- 	} else {
- 		$link = remove_query_arg( 'post_format', $link );
- 		return add_query_arg( 'post_format', str_replace( 'post-format-', '', $term->slug ), $link );
- 	}
- }
- add_filter( 'term_link', '_post_format_link', 10, 3 );
- 
- /**
-  * Remove the post format prefix from the name property of the term object created by get_term().
-  *
-  * @access private
-  * @since 3.1.0
-  */
- function _post_format_get_term( $term ) {
- 	if ( isset( $term->slug ) ) {
- 		$term->name = get_post_format_string( str_replace( 'post-format-', '', $term->slug ) );
- 	}
- 	return $term;
- }
- add_filter( 'get_post_format', '_post_format_get_term' );
- 
- /**
-  * Remove the post format prefix from the name property of the term objects created by get_terms().
-  *
-  * @access private
-  * @since 3.1.0
-  */
- function _post_format_get_terms( $terms, $taxonomies, $args ) {
- 	if ( in_array( 'post_format', (array) $taxonomies ) ) {
- 		if ( isset( $args['fields'] ) && 'names' == $args['fields'] ) {
- 			foreach( $terms as $order => $name ) {
- 				$terms[$order] = get_post_format_string( str_replace( 'post-format-', '', $name ) );
- 			}
- 		} else {
- 			foreach ( (array) $terms as $order => $term ) {
- 				if ( isset( $term->taxonomy ) && 'post_format' == $term->taxonomy ) {
- 					$terms[$order]->name = get_post_format_string( str_replace( 'post-format-', '', $term->slug ) );
- 				}
- 			}
- 		}
- 	}
- 	return $terms;
- }
- add_filter( 'get_terms', '_post_format_get_terms', 10, 3 );
- 
- /**
-  * Remove the post format prefix from the name property of the term objects created by wp_get_object_terms().
-  *
-  * @access private
-  * @since 3.1.0
-  */
- function _post_format_wp_get_object_terms( $terms ) {
- 	foreach ( (array) $terms as $order => $term ) {
- 		if ( isset( $term->taxonomy ) && 'post_format' == $term->taxonomy ) {
- 			$terms[$order]->name = get_post_format_string( str_replace( 'post-format-', '', $term->slug ) );
- 		}
- 	}
- 	return $terms;
- }
- add_filter( 'wp_get_object_terms', '_post_format_wp_get_object_terms' );
- 
- /**
   * Update the custom taxonomies' term counts when a post's status is changed. For example, default posts term counts (for custom taxonomies) don't include private / draft posts.
   *
   * @access private
--- 4932,4937 ----
